(?:_?[0-7])+">
        <token type="LiteralNumberOct"/>
      </rule>
      <rule pattern="0x(?:_?[0-9a-fA-F])+">
        <token type="LiteralNumberHex"/>
      </rule>
      <rule pattern="(?:_?[0-9])+">
        <token type="LiteralNumberInteger"/>
      </rule>
      <rule pattern="\b[A-Za-z_]\w*(?=\s*\()">
        <token type="NameFunction"/>
      </rule>
      <rule pattern="@[a-zA-Z_]\w*">
        <token type="NameBuiltin"/>
      </rule>
      <rule pattern="[a-zA-Z_]\w*">
        <token type="Name"/>
      </rule>
      <rule pattern="\&#39;\\\&#39;\&#39;">
        <token type="LiteralStringEscape"/>
      </rule>
      <rule pattern="\&#39;\\(|x[a-fA-F0-9]{2}|u[a-fA-F0-9]{4}|U[a-fA-F0-9]{6}|[nr\\t\&#39;&#34;])\&#39;">
        <token type="LiteralStringEscape"/>
      </rule>
      <rule pattern="\&#39;[^\\\&#39;]\&#39;">
        <token type="LiteralString"/>
      </rule>
      <rule pattern="\\\\[^\n]*">
        <token type="LiteralStringHeredoc"/>
      </rule>
      <rule pattern="c\\\\[^\n]*">
        <token type="LiteralStringHeredoc"/>
      </rule>
      <rule pattern="c?&#34;">
        <token type="LiteralString"/>
        <push state="string"/>
      </rule>
      <rule pattern="[+%=&gt;&lt;|^!?/\-*&amp;~:]">
        <token type="Operator"/>
      </rule>
      <rule pattern="[{}()\[\],.;]">
        <token type="Punctuation"/>
      </rule>
    </state>
  </rules>
</lexer>